> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/software-delivery-agent-apis/gitops/applications.md).

# Applications

## List applications for a specific agent

> List returns a list of applications for a specific agent.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/applications":{"get":{"summary":"List applications for a specific agent","description":"List returns a list of applications for a specific agent.","operationId":"AgentApplicationService_List","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/applicationsApplicationList"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.name","description":"the application's name.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.refresh","description":"set to \"normal\" OR \"hard\" if an application refresh is required before fetching.\n\nnormal refresh only if source has changed(commit, helm chart version, etc.)\n\nhard refresh will invalidate all generated manifest caches and force regeneration.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.project","description":"the project names to restrict returned list applications.","in":"query","required":false,"explode":true,"schema":{"type":"array","items":{"type":"string"}}},{"name":"query.resourceVersion","description":"when specified with a watch call, shows changes that occur after that particular version of a resource.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.selector","description":"the selector to to restrict returned list to applications only with matched labels.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.repo","description":"the repoURL to restrict returned list applications.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.appNamespace","in":"query","required":false,"schema":{"type":"string"}},{"name":"fetchFromHarness","description":"fetchFromHarness is used in Get Application API to fetch application directly from mongodb instead of from agent. Use in Get Application API to fetch application directly from harness. This is already the fallback if the task times out on Gitops Agent. Use with caution as this may not return the latest state of application.","in":"query","required":false,"schema":{"type":"boolean"}}],"tags":["Applications"]}}},"components":{"schemas":{"applicationsApplicationList":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ListMeta"},"items":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplication"}}},"title":"ApplicationList is list of Application resources\n+k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object"},"v1ListMeta":{"type":"object","properties":{"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"resourceVersion":{"type":"string","title":"String that identifies the server's internal version of this object that\ncan be used by clients to determine when objects have changed.\nValue must be treated as opaque by clients and passed unmodified back to the server.\nPopulated by the system.\nRead-only.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"continue":{"type":"string","description":"continue may be set if the user set a limit on the number of items returned, and indicates that\nthe server has more data available. The value is opaque and may be used to issue another request\nto the endpoint that served this list to retrieve the next set of available objects. Continuing a\nconsistent list may not be possible if the server configuration has changed or more than a few\nminutes have passed. The resourceVersion field returned when using this continue value will be\nidentical to the value in the first response, unless you have received this token from an error\nmessage."},"remainingItemCount":{"type":"string","format":"int64","title":"remainingItemCount is the number of subsequent items in the list which are not included in this\nlist response. If the list request contained label or field selectors, then the number of\nremaining items is unknown and the field will be left unset and omitted during serialization.\nIf the list is complete (either because it is not chunking or because this is the last chunk),\nthen there are no more remaining items and this field will be left unset and omitted during\nserialization.\nServers older than v1.15 do not set this field.\nThe intended use of the remainingItemCount is *estimating* the size of a collection. Clients\nshould not rely on the remainingItemCount to be set or to be exact.\n+optional"},"shardInfo":{"$ref":"#/components/schemas/v1ShardInfo"}},"description":"ListMeta describes metadata that synthetic resources must have, including lists and\nvarious status objects. A resource may have only one of {ObjectMeta, ListMeta}."},"v1ShardInfo":{"type":"object","properties":{"selector":{"type":"string","title":"selector is the shard selector string from the request, echoed back so clients\ncan verify which shard they received and merge responses from multiple shards.\n+required"}},"description":"ShardInfo describes the shard selector that was applied to produce a list response.\nIts presence on a list response indicates the list is a filtered subset."},"applicationsApplication":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSpec"},"status":{"$ref":"#/components/schemas/applicationsApplicationStatus"},"operation":{"$ref":"#/components/schemas/applicationsOperation"},"creationTimestampTs":{"type":"string","format":"date-time","title":"Protobuf-safe copy of ObjectMeta.CreationTimestamp (v1.Time doesn't survive gRPC serialization)"}}},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsApplicationSpec":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"destination":{"$ref":"#/components/schemas/applicationsApplicationDestination"},"project":{"type":"string","description":"Project is a reference to the project this application belongs to.\nThe empty string means that application belongs to the 'default' project."},"syncPolicy":{"$ref":"#/components/schemas/applicationsSyncPolicy"},"ignoreDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceIgnoreDifferences"},"title":"IgnoreDifferences is a list of resources and their fields which should be ignored during comparison"},"info":{"type":"array","items":{"$ref":"#/components/schemas/applicationsInfo"},"title":"Info contains a list of information (URLs, email addresses, and plain text) that relates to the application"},"revisionHistoryLimit":{"type":"string","format":"int64","description":"RevisionHistoryLimit limits the number of items kept in the application's revision history, which is used for informational purposes as well as for rollbacks to previous versions.\nThis should only be changed in exceptional circumstances.\nSetting to zero will store no history. This will reduce storage used.\nIncreasing will increase the space used to store the history, so we do not recommend increasing it.\nDefault is 10."},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the location of the application's manifests or chart"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"description":"ApplicationSpec represents desired application state. Contains link to repository with application definition and additional parameters link definition revision."},"applicationsApplicationSource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the repository (Git or Helm) that contains the application manifests"},"path":{"type":"string","description":"Path is a directory path within the Git repository, and is only valid for applications sourced from Git."},"targetRevision":{"type":"string","description":"TargetRevision defines the revision of the source to sync the application to.\nIn case of Git, this can be commit, tag, or branch. If omitted, will equal to HEAD.\nIn case of Helm, this is a semver tag for the Chart's version."},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"ksonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceKsonnet"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"},"chart":{"type":"string","description":"Chart is a Helm chart name, and must be specified for applications sourced from a Helm repo."},"ref":{"type":"string","description":"Ref is reference to another source within sources field. This field will not be used if used with a `source` tag."},"name":{"type":"string","description":"Name is used to refer to a source and is displayed in the UI. It is used in multi-source Applications."},"tagPrefix":{"type":"string","description":"TagPrefix filters git tags to only those with this prefix before evaluating targetRevision as a semver constraint.\nThe prefix is stripped from tag names before comparison and re-added to the resolved version.\nFor example, with tagPrefix \"component-b/\" and targetRevision \"1.0.*\", tags like \"component-b/1.0.0\" and\n\"component-b/1.0.1\" are candidates, and the constraint resolves to \"component-b/1.0.1\"."}},"title":"ApplicationSource contains all information about the source of an application"},"applicationsApplicationSourceHelm":{"type":"object","properties":{"valueFiles":{"type":"array","items":{"type":"string"},"title":"ValuesFiles is a list of Helm value files to use when generating a template"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmParameter"},"title":"Parameters is a list of Helm parameters which are passed to the helm template command upon manifest generation"},"releaseName":{"type":"string","title":"ReleaseName is the Helm release name to use. If omitted it will use the application name"},"values":{"type":"string","title":"Values specifies Helm values to be passed to helm template, typically defined as a block"},"fileParameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmFileParameter"},"title":"FileParameters are file parameters to the helm template"},"version":{"type":"string","title":"Version is the Helm version to use for templating (either \"2\" or \"3\")"},"passCredentials":{"type":"boolean","title":"PassCredentials pass credentials to all domains (Helm's --pass-credentials)"},"ignoreMissingValueFiles":{"type":"boolean","title":"IgnoreMissingValueFiles prevents helm template from failing when valueFiles do not exist locally by not appending them to helm template --values"},"skipCrds":{"type":"boolean","title":"SkipCrds skips custom resource definition installation step (Helm's --skip-crds)"},"valuesObject":{"type":"object","title":"ValuesObject specifies Helm values to be passed to helm template, defined as a map. This takes precedence over Values.\n+kubebuilder:pruning:PreserveUnknownFields"},"namespace":{"type":"string","description":"Namespace is an optional namespace to template with. If left empty, defaults to the app's destination namespace."},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"skipTests":{"type":"boolean","description":"SkipTests skips test manifest installation step (Helm's --skip-tests)."},"skipSchemaValidation":{"type":"boolean","title":"SkipSchemaValidation skips JSON schema validation (Helm's --skip-schema-validation)"}},"title":"ApplicationSourceHelm holds helm specific options\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsHelmParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"value":{"type":"string","title":"Value is the value for the Helm parameter"},"forceString":{"type":"boolean","title":"ForceString determines whether to tell Helm to interpret booleans and numbers as strings"}},"title":"HelmParameter is a parameter that's passed to helm template during manifest generation"},"applicationsHelmFileParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"path":{"type":"string","title":"Path is the path to the file containing the values for the Helm parameter"}},"title":"HelmFileParameter is a file parameter that's passed to helm template during manifest generation"},"applicationsApplicationSourceKustomize":{"type":"object","properties":{"namePrefix":{"type":"string","title":"NamePrefix overrides the namePrefix in the kustomization.yaml for Kustomize apps"},"nameSuffix":{"type":"string","title":"NameSuffix overrides the nameSuffix in the kustomization.yaml for Kustomize apps"},"images":{"type":"array","items":{"type":"string"},"title":"Images is a list of Kustomize image override specifications"},"commonLabels":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonLabels is a list of additional labels to add to rendered manifests"},"version":{"type":"string","title":"Version controls which version of Kustomize to use for rendering manifests"},"commonAnnotations":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonAnnotations is a list of additional annotations to add to rendered manifests"},"forceCommonLabels":{"type":"boolean","title":"ForceCommonLabels specifies whether to force applying common labels to resources for Kustomize apps"},"forceCommonAnnotations":{"type":"boolean","title":"ForceCommonAnnotations specifies whether to force applying common annotations to resources for Kustomize apps"},"namespace":{"type":"string","title":"Namespace sets the namespace that Kustomize adds to all resources"},"commonAnnotationsEnvsubst":{"type":"boolean","title":"CommonAnnotationsEnvsubst specifies whether to apply env variables substitution for annotation values"},"replicas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizeReplicas"},"title":"Replicas is a list of Kustomize Replicas override specifications"},"patches":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizePatch"},"title":"Patches is a list of Kustomize patches"},"components":{"type":"array","items":{"type":"string"},"title":"Components specifies a list of kustomize components to add to the kustomization before building"},"labelWithoutSelector":{"type":"boolean","title":"LabelWithoutSelector specifies whether to apply common labels to resource selectors or not"},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"ignoreMissingComponents":{"type":"boolean","title":"IgnoreMissingComponents prevents kustomize from failing when components do not exist locally by not appending them to kustomization file"},"labelIncludeTemplates":{"type":"boolean","title":"LabelIncludeTemplates specifies whether to apply common labels to resource templates or not"}},"title":"ApplicationSourceKustomize holds options specific to an Application source specific to Kustomize"},"applicationsKustomizeReplicas":{"type":"object","properties":{"count":{"type":"string","title":"Number of replicas"},"name":{"type":"string","title":"Name of Deployment or StatefulSet"}}},"applicationsKustomizePatch":{"type":"object","properties":{"path":{"type":"string"},"patch":{"type":"string"},"target":{"$ref":"#/components/schemas/applicationsKustomizeSelector"},"options":{"type":"object","additionalProperties":{"type":"boolean"}}}},"applicationsKustomizeSelector":{"type":"object","properties":{"resId":{"$ref":"#/components/schemas/applicationsKustomizeResId"},"annotationSelector":{"type":"string"},"labelSelector":{"type":"string"}}},"applicationsKustomizeResId":{"type":"object","properties":{"gvk":{"$ref":"#/components/schemas/applicationsKustomizeGvk"},"name":{"type":"string"},"namespace":{"type":"string"}}},"applicationsKustomizeGvk":{"type":"object","properties":{"group":{"type":"string"},"version":{"type":"string"},"kind":{"type":"string"}}},"applicationsApplicationSourceKsonnet":{"type":"object","properties":{"environment":{"type":"string","title":"Environment is a ksonnet application environment name"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKsonnetParameter"},"title":"Parameters are a list of ksonnet component parameter override values"}},"title":"ApplicationSourceKsonnet holds ksonnet specific options"},"applicationsKsonnetParameter":{"type":"object","properties":{"component":{"type":"string"},"name":{"type":"string"},"value":{"type":"string"}},"title":"KsonnetParameter is a ksonnet component parameter"},"applicationsApplicationSourceDirectory":{"type":"object","properties":{"recurse":{"type":"boolean","title":"Recurse specifies whether to scan a directory recursively for manifests"},"jsonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceJsonnet"},"exclude":{"type":"string","title":"Exclude contains a glob pattern to match paths against that should be explicitly excluded from being used during manifest generation"},"include":{"type":"string","title":"Include contains a glob pattern to match paths against that should be explicitly included during manifest generation"}},"title":"ApplicationSourceDirectory holds options for applications of type plain YAML or Jsonnet"},"applicationsApplicationSourceJsonnet":{"type":"object","properties":{"extVars":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"ExtVars is a list of Jsonnet External Variables"},"tlas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"TLAS is a list of Jsonnet Top-level Arguments"},"libs":{"type":"array","items":{"type":"string"},"title":"Additional library search dirs"}},"title":"ApplicationSourceJsonnet holds options specific to applications of type Jsonnet"},"applicationsJsonnetVar":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"},"code":{"type":"boolean"}},"title":"JsonnetVar represents a variable to be passed to jsonnet during manifest generation"},"applicationsApplicationSourcePlugin":{"type":"object","properties":{"name":{"type":"string"},"env":{"type":"array","items":{"$ref":"#/components/schemas/applicationsEnvEntry"}},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSourcePluginParameter"}}},"title":"ApplicationSourcePlugin holds options specific to config management plugins"},"applicationsEnvEntry":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the variable, usually expressed in uppercase"},"value":{"type":"string","title":"Value is the value of the variable"}},"title":"EnvEntry represents an entry in the application's environment"},"applicationsApplicationSourcePluginParameter":{"type":"object","properties":{"name":{"type":"string","description":"Name is the name identifying a parameter."},"string":{"type":"string","description":"String_ is the value of a string type parameter."},"map":{"$ref":"#/components/schemas/applicationsOptionalMap"},"array":{"$ref":"#/components/schemas/applicationsOptionalArray"}}},"applicationsOptionalMap":{"type":"object","properties":{"map":{"type":"object","additionalProperties":{"type":"string"},"title":"Map is the value of a map type parameter.\n+optional"}}},"applicationsOptionalArray":{"type":"object","properties":{"array":{"type":"array","items":{"type":"string"},"title":"Array is the value of an array type parameter.\n+optional"}}},"applicationsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"applicationsSyncPolicy":{"type":"object","properties":{"automated":{"$ref":"#/components/schemas/applicationsSyncPolicyAutomated"},"syncOptions":{"type":"array","items":{"type":"string"},"title":"Options allow you to specify whole app sync-options"},"retry":{"$ref":"#/components/schemas/applicationsRetryStrategy"},"managedNamespaceMetadata":{"$ref":"#/components/schemas/applicationsManagedNamespaceMetadata"}},"title":"SyncPolicy controls when a sync will be performed in response to updates in git"},"applicationsSyncPolicyAutomated":{"type":"object","properties":{"prune":{"type":"boolean","title":"Prune specifies whether to delete resources from the cluster that are not found in the sources anymore as part of automated sync (default: false)"},"selfHeal":{"type":"boolean","title":"SelfHeal specifes whether to revert resources back to their desired state upon modification in the cluster (default: false)"},"allowEmpty":{"type":"boolean","title":"AllowEmpty allows apps have zero live resources (default: false)"},"enabled":{"type":"boolean","title":"Enable allows apps to explicitly control automated sync"}},"title":"SyncPolicyAutomated controls the behavior of an automated sync"},"applicationsRetryStrategy":{"type":"object","properties":{"limit":{"type":"string","format":"int64","description":"Limit is the maximum number of attempts for retrying a failed sync. If set to 0, no retries will be performed."},"backoff":{"$ref":"#/components/schemas/applicationsBackoff"},"refresh":{"type":"boolean","title":"Refresh indicates if the latest revision should be used on retry instead of the initial one (default: false)"}},"title":"RetryStrategy contains information about the strategy to apply when a sync failed"},"applicationsBackoff":{"type":"object","properties":{"duration":{"type":"string","title":"Duration is the amount to back off. Default unit is seconds, but could also be a duration (e.g. \"2m\", \"1h\")"},"factor":{"type":"string","format":"int64","title":"Factor is a factor to multiply the base duration after each failed retry"},"maxDuration":{"type":"string","title":"MaxDuration is the maximum amount of time allowed for the backoff strategy"}},"title":"Backoff is the backoff strategy to use on subsequent retries for failing syncs"},"applicationsManagedNamespaceMetadata":{"type":"object","properties":{"labels":{"type":"object","additionalProperties":{"type":"string"}},"annotations":{"type":"object","additionalProperties":{"type":"string"}}}},"applicationsResourceIgnoreDifferences":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"},"namespace":{"type":"string"},"jsonPointers":{"type":"array","items":{"type":"string"}},"jqPathExpressions":{"type":"array","items":{"type":"string"}},"managedFieldsManagers":{"type":"array","items":{"type":"string"},"title":"ManagedFieldsManagers is a list of trusted managers. Fields mutated by those managers will take precedence over the\ndesired state defined in the SCM and won't be displayed in diffs"}},"description":"ResourceIgnoreDifferences contains resource filter and list of json paths which should be ignored during comparison with live state."},"applicationsInfo":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"}}},"applicationsSourceHydrator":{"type":"object","properties":{"drySource":{"$ref":"#/components/schemas/applicationsDrySource"},"syncSource":{"$ref":"#/components/schemas/applicationsSyncSource"},"hydrateTo":{"$ref":"#/components/schemas/applicationsHydrateTo"}},"description":"SourceHydrator specifies a dry \"don't repeat yourself\" source for manifests, a sync source from which to sync\nhydrated manifests, and an optional hydrateTo location to act as a \"staging\" aread for hydrated manifests."},"applicationsDrySource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the git repository that contains the application manifests"},"targetRevision":{"type":"string","title":"TargetRevision defines the revision of the source to hydrate"},"path":{"type":"string","title":"Path is a directory path within the Git repository where the manifests are located"},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"}},"description":"DrySource specifies a location for dry \"don't repeat yourself\" manifest source information."},"applicationsSyncSource":{"type":"object","properties":{"targetBranch":{"type":"string","description":"TargetBranch is the branch from which hydrated manifests will be synced.\nIf HydrateTo is not set, this is also the branch to which hydrated manifests are committed."},"path":{"type":"string","description":"Path is a directory path within the git repository where hydrated manifests should be committed to and synced\nfrom. The Path should never point to the root of the repo. If hydrateTo is set, this is just the path from which\nhydrated manifests will be synced.\n\n+kubebuilder:validation:Required\n+kubebuilder:validation:MinLength=1\n+kubebuilder:validation:Pattern=`^.{2,}|[^./]$`"},"repoURL":{"type":"string","description":"RepoURL is the URL to the git repository that contains the hydrated manifests. If not set, defaults to\nthe DrySource.RepoURL."}},"description":"SyncSource specifies a location from which hydrated manifests may be synced. If RepoURL is not set, it is assumed\nto be the same as the associated DrySource config in the SourceHydrator."},"applicationsHydrateTo":{"type":"object","properties":{"targetBranch":{"type":"string","title":"TargetBranch is the branch to which hydrated manifests should be committed"}},"description":"HydrateTo specifies a branch to which hydrated manifests should be pushed as a \"staging area\" before being moved to\nthe SyncSource. The repository and path are inherited from SyncSource."},"applicationsApplicationStatus":{"type":"object","properties":{"resources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceStatus"},"title":"Resources is a list of Kubernetes resources managed by this application"},"sync":{"$ref":"#/components/schemas/applicationsSyncStatus"},"health":{"$ref":"#/components/schemas/applicationsAppHealthStatus"},"history":{"type":"array","items":{"$ref":"#/components/schemas/applicationsRevisionHistory"},"title":"History contains information about the application's sync history"},"conditions":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationCondition"},"title":"Conditions is a list of currently observed application conditions"},"reconciledAt":{"$ref":"#/components/schemas/v1Time"},"operationState":{"$ref":"#/components/schemas/applicationsOperationState"},"observedAt":{"$ref":"#/components/schemas/v1Time"},"sourceType":{"type":"string","title":"SourceType specifies the type of this application"},"summary":{"$ref":"#/components/schemas/applicationsApplicationSummary"},"resourceHealthSource":{"type":"string","title":"ResourceHealthSource indicates where the resource health status is stored: inline if not set or appTree"},"sourceTypes":{"type":"array","items":{"type":"string"},"title":"SourceTypes specifies the type of the sources included in the application"},"controllerNamespace":{"type":"string","title":"ControllerNamespace indicates the namespace in which the application controller is located"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydratorStatus"}},"title":"ApplicationStatus contains status information for the application"},"applicationsResourceStatus":{"type":"object","properties":{"group":{"type":"string","description":"Group represents the API group of the resource (e.g., \"apps\" for Deployments)."},"version":{"type":"string","description":"Version indicates the API version of the resource (e.g., \"v1\", \"v1beta1\")."},"kind":{"type":"string","description":"Kind specifies the type of the resource (e.g., \"Deployment\", \"Service\")."},"namespace":{"type":"string","description":"Namespace defines the Kubernetes namespace where the resource is located."},"name":{"type":"string","description":"Name is the unique name of the resource within the namespace."},"status":{"type":"string","description":"Status represents the synchronization state of the resource (e.g., Synced, OutOfSync)."},"health":{"$ref":"#/components/schemas/applicationsHealthStatus"},"hook":{"type":"boolean","description":"Hook is true if the resource is used as a lifecycle hook in an Argo CD application."},"requiresPruning":{"type":"boolean","description":"RequiresPruning is true if the resource needs to be pruned (deleted) as part of synchronization."},"syncWave":{"type":"string","format":"int64","description":"SyncWave determines the order in which resources are applied during a sync operation.\nLower values are applied first."},"requiresDeletionConfirmation":{"type":"boolean","description":"RequiresDeletionConfirmation is true if the resource requires explicit user confirmation before deletion."}},"description":"ResourceStatus holds the current synchronization and health status of a Kubernetes resource."},"applicationsHealthStatus":{"type":"object","properties":{"status":{"type":"string","title":"Status holds the status code of the application or resource"},"message":{"type":"string","title":"Message is a human-readable informational message describing the health status"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"}},"title":"HealthStatus contains information about the currently observed health state of a resource"},"applicationsSyncStatus":{"type":"object","properties":{"status":{"type":"string","title":"Status is the sync state of the comparison"},"comparedTo":{"$ref":"#/components/schemas/applicationsComparedTo"},"revision":{"type":"string","title":"Revision contains information about the revision the comparison has been performed to"},"revisions":{"type":"array","items":{"type":"string"},"title":"Revisions contains information about the revisions of multiple sources the comparison has been performed to"}},"title":"SyncStatus contains information about the currently observed live and desired states of an application"},"applicationsComparedTo":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"destination":{"$ref":"#/components/schemas/applicationsApplicationDestination"},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the application's multiple sources used for comparison"},"ignoreDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceIgnoreDifferences"},"title":"IgnoreDifferences is a reference to the application's ignored differences used for comparison"}},"title":"ComparedTo contains application source and target which was used for resources comparison"},"applicationsAppHealthStatus":{"type":"object","properties":{"status":{"type":"string","title":"Status holds the status code of the application"},"message":{"type":"string","description":"Deprecated: this field is not used and will be removed in a future release.","title":"Message is a human-readable informational message describing the health status"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"}},"title":"AppHealthStatus contains information about the currently observed health state of an application"},"applicationsRevisionHistory":{"type":"object","properties":{"revision":{"type":"string","title":"Revision holds the revision the sync was performed against"},"deployedAt":{"$ref":"#/components/schemas/v1Time"},"id":{"type":"string","format":"int64","title":"ID is an auto incrementing identifier of the RevisionHistory"},"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"deployStartedAt":{"$ref":"#/components/schemas/v1Time"},"deployedAtTs":{"type":"string","format":"date-time"},"deployStartedAtTs":{"type":"string","format":"date-time"},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the application sources used for the sync operation"},"revisions":{"type":"array","items":{"type":"string"},"title":"Revisions holds the revision of each source in sources field the sync was performed against"},"initiatedBy":{"$ref":"#/components/schemas/applicationsOperationInitiator"}},"title":"RevisionHistory contains history information about a previous sync"},"applicationsOperationInitiator":{"type":"object","properties":{"username":{"type":"string","title":"Username contains the name of a user who started operation"},"automated":{"type":"boolean","description":"Automated is set to true if operation was initiated automatically by the application controller."}},"title":"OperationInitiator contains information about the initiator of an operation"},"applicationsApplicationCondition":{"type":"object","properties":{"type":{"type":"string","title":"Type is an application condition type"},"message":{"type":"string","title":"Message contains human-readable message indicating details about condition"},"lastTransitionTime":{"$ref":"#/components/schemas/v1Time"},"lastTransitionTimeTs":{"type":"string","format":"date-time","title":"LastTransitionTimeTs is the google timestamp variation of LastTransitionTime"}},"title":"ApplicationCondition contains details about an application condition, which is usally an error or warning"},"applicationsOperationState":{"type":"object","properties":{"operation":{"$ref":"#/components/schemas/applicationsOperation"},"phase":{"type":"string","title":"Phase is the current phase of the operation"},"message":{"type":"string","description":"Message holds any pertinent messages when attempting to perform operation (typically errors)."},"syncResult":{"$ref":"#/components/schemas/applicationsSyncOperationResult"},"startedAt":{"$ref":"#/components/schemas/v1Time"},"finishedAt":{"$ref":"#/components/schemas/v1Time"},"retryCount":{"type":"string","format":"int64","title":"RetryCount contains time of operation retries"},"startedAtTs":{"type":"string","format":"date-time","title":"Started at Timestamp"},"finishedAtTs":{"type":"string","format":"date-time","title":"Finised at Timestamp"}},"title":"OperationState contains information about state of a running operation"},"applicationsOperation":{"type":"object","properties":{"sync":{"$ref":"#/components/schemas/applicationsSyncOperation"},"initiatedBy":{"$ref":"#/components/schemas/applicationsOperationInitiator"},"info":{"type":"array","items":{"$ref":"#/components/schemas/applicationsInfo"},"title":"Info is a list of informational items for this operation"},"retry":{"$ref":"#/components/schemas/applicationsRetryStrategy"}},"title":"Operation contains information about a requested or running operation"},"applicationsSyncOperation":{"type":"object","properties":{"revision":{"type":"string","description":"Revision is the revision (Git) or chart version (Helm) which to sync the application to\nIf omitted, will use the revision specified in app spec."},"prune":{"type":"boolean","title":"Prune specifies to delete resources from the cluster that are no longer tracked in git"},"dryRun":{"type":"boolean","title":"DryRun specifies to perform a `kubectl apply --dry-run` without actually performing the sync"},"syncStrategy":{"$ref":"#/components/schemas/applicationsSyncStrategy"},"resources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsSyncOperationResource"},"title":"Resources describes which resources shall be part of the sync"},"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"manifests":{"type":"array","items":{"type":"string"},"title":"Manifests is an field that overrides sync source with a local directory for development"},"syncOptions":{"type":"array","items":{"type":"string"},"title":"SyncOptions provide per-sync sync-options, e.g. Validate=false"},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources overrides the source definition set in the application.\nThis is typically set in a Rollback operation and is nil during a Sync operation"},"revisions":{"type":"array","items":{"type":"string"},"description":"Revisions is the list of revision (Git) or chart version (Helm) which to sync each source in sources field for the application to\nIf omitted, will use the revision specified in app spec."},"autoHealAttemptsCount":{"type":"string","format":"int64","title":"SelfHealAttemptsCount contains the number of auto-heal attempts"}},"description":"SyncOperation contains details about a sync operation."},"applicationsSyncStrategy":{"type":"object","properties":{"apply":{"$ref":"#/components/schemas/applicationsSyncStrategyApply"},"hook":{"$ref":"#/components/schemas/applicationsSyncStrategyHook"}},"title":"SyncStrategy controls the manner in which a sync is performed"},"applicationsSyncStrategyApply":{"type":"object","properties":{"force":{"type":"boolean","description":"Force indicates whether or not to supply the --force flag to `kubectl apply`.\nThe --force flag deletes and re-create the resource, when PATCH encounters conflict and has\nretried for 5 times."}},"title":"SyncStrategyApply uses `kubectl apply` to perform the apply"},"applicationsSyncStrategyHook":{"type":"object","properties":{"force":{"type":"boolean","title":"Embed SyncStrategyApply type to inherit any `apply` options\n+"}},"description":"SyncStrategyHook will perform a sync using hooks annotations.\nIf no hook annotation is specified falls back to `kubectl apply`."},"applicationsSyncOperationResource":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"},"namespace":{"type":"string"}},"description":"SyncOperationResource contains resources to sync."},"applicationsSyncOperationResult":{"type":"object","properties":{"resources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceResult"},"title":"Resources contains a list of sync result items for each individual resource in a sync operation"},"revision":{"type":"string","title":"Revision holds the revision this sync operation was performed to"},"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Source records the application source information of the sync, used for comparing auto-sync"},"revisions":{"type":"array","items":{"type":"string"},"title":"Revisions holds the revision this sync operation was performed for respective indexed source in sources field"},"managedNamespaceMetadata":{"$ref":"#/components/schemas/applicationsManagedNamespaceMetadata"}},"title":"SyncOperationResult represent result of sync operation"},"applicationsResourceResult":{"type":"object","properties":{"group":{"type":"string","title":"Group specifies the API group of the resource"},"version":{"type":"string","title":"Version specifies the API version of the resource"},"kind":{"type":"string","title":"Kind specifies the API kind of the resource"},"namespace":{"type":"string","title":"Namespace specifies the target namespace of the resource"},"name":{"type":"string","title":"Name specifies the name of the resource"},"status":{"type":"string","title":"Status holds the final result of the sync. Will be empty if the resources is yet to be applied/pruned and is always zero-value for hooks"},"message":{"type":"string","title":"Message contains an informational or error message for the last sync OR operation"},"hookType":{"type":"string","title":"HookType specifies the type of the hook. Empty for non-hook resources"},"hookPhase":{"type":"string","description":"HookPhase contains the state of any operation associated with this resource OR hook\nThis can also contain values for non-hook resources."},"syncPhase":{"type":"string","title":"SyncPhase indicates the particular phase of the sync that this result was acquired in"},"images":{"type":"array","items":{"type":"string"},"title":"Images contains the images related to the ResourceResult"}},"title":"ResourceResult holds the operation result details of a specific resource"},"applicationsApplicationSummary":{"type":"object","properties":{"externalURLs":{"type":"array","items":{"type":"string"},"description":"ExternalURLs holds all external URLs of application child resources."},"images":{"type":"array","items":{"type":"string"},"description":"Images holds all images of application child resources."},"isAppOfApps":{"type":"boolean","description":"IsAppOfApps holds true if the application has any application for child resource."}},"title":"ApplicationSummary contains information about URLs and container images used by an application"},"applicationsSourceHydratorStatus":{"type":"object","properties":{"lastSuccessfulOperation":{"$ref":"#/components/schemas/applicationsSuccessfulHydrateOperation"},"currentOperation":{"$ref":"#/components/schemas/applicationsHydrateOperation"},"lastComparedDryRevision":{"type":"string","description":"LastComparedDryRevision holds the resolved revision from the most recent dry source comparison.\nThis is updated on every evaluation, even when hydration is skipped due to no changes."}},"title":"SourceHydratorStatus contains information about the current state of source hydration"},"applicationsSuccessfulHydrateOperation":{"type":"object","properties":{"drySHA":{"type":"string","title":"DrySHA holds the resolved revision (sha) of the dry source as of the most recent reconciliation"},"hydratedSHA":{"type":"string","title":"HydratedSHA holds the resolved revision (sha) of the hydrated source as of the most recent reconciliation"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"title":"SuccessfulHydrateOperation contains information about the most recent successful hydrate operation"},"applicationsHydrateOperation":{"type":"object","properties":{"startedAt":{"$ref":"#/components/schemas/v1Time"},"finishedAt":{"$ref":"#/components/schemas/v1Time"},"phase":{"type":"string","title":"Phase indicates the status of the hydrate operation"},"message":{"type":"string","title":"Message contains a message describing the current status of the hydrate operation"},"drySHA":{"type":"string","title":"DrySHA holds the resolved revision (sha) of the dry source as of the most recent reconciliation"},"hydratedSHA":{"type":"string","title":"HydratedSHA holds the resolved revision (sha) of the hydrated source as of the most recent reconciliation"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"title":"HydrateOperation contains information about the most recent hydrate operation"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## Create an application

> Create creates a new application in the specified project.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/applications":{"post":{"summary":"Create an application","description":"Create creates a new application in the specified project.","operationId":"AgentApplicationService_Create","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/servicev1Application"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"clusterIdentifier","in":"query","required":false,"schema":{"type":"string"}},{"name":"repoIdentifier","in":"query","required":false,"schema":{"type":"string"}},{"name":"skipRepoValidation","in":"query","required":false,"schema":{"type":"boolean"}},{"name":"repoIdentifiers","in":"query","required":false,"explode":true,"schema":{"type":"array","items":{"type":"string"}}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/applicationsApplicationCreateRequest"}}},"required":true},"tags":["Applications"]}}},"components":{"schemas":{"servicev1Application":{"type":"object","properties":{"accountIdentifier":{"type":"string","description":"Account Identifier for the Entity."},"orgIdentifier":{"type":"string","description":"Organization Identifier for the Entity."},"projectIdentifier":{"type":"string","description":"Project Identifier for the Entity."},"agentIdentifier":{"type":"string","description":"Agent identifier for entity."},"name":{"type":"string"},"clusterIdentifier":{"type":"string"},"repoIdentifier":{"type":"string"},"app":{"$ref":"#/components/schemas/applicationsApplication"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"stale":{"type":"boolean"},"skipRepoValidation":{"type":"boolean"},"repoIdentifiers":{"type":"array","items":{"type":"string"}},"parentAppRef":{"type":"string","description":"Reference of owner application (Application Set)"},"governanceMetadata":{"$ref":"#/components/schemas/v1GovernanceMetadata"},"uuid":{"type":"string","description":"Kubernetes ObjectMeta.UID of the Application."},"subId":{"type":"string","description":"Sub-identifier for ConfigMap-extracted entities; empty for Applications."},"agentUuid":{"type":"string","description":"UID of the parent agent document."}}},"applicationsApplication":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/applicationsApplicationSpec"},"status":{"$ref":"#/components/schemas/applicationsApplicationStatus"},"operation":{"$ref":"#/components/schemas/applicationsOperation"},"creationTimestampTs":{"type":"string","format":"date-time","title":"Protobuf-safe copy of ObjectMeta.CreationTimestamp (v1.Time doesn't survive gRPC serialization)"}}},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsApplicationSpec":{"type":"object","properties":{"source":{"$ref":"#/components/schemas/applicationsApplicationSource"},"destination":{"$ref":"#/components/schemas/applicationsApplicationDestination"},"project":{"type":"string","description":"Project is a reference to the project this application belongs to.\nThe empty string means that application belongs to the 'default' project."},"syncPolicy":{"$ref":"#/components/schemas/applicationsSyncPolicy"},"ignoreDifferences":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceIgnoreDifferences"},"title":"IgnoreDifferences is a list of resources and their fields which should be ignored during comparison"},"info":{"type":"array","items":{"$ref":"#/components/schemas/applicationsInfo"},"title":"Info contains a list of information (URLs, email addresses, and plain text) that relates to the application"},"revisionHistoryLimit":{"type":"string","format":"int64","description":"RevisionHistoryLimit limits the number of items kept in the application's revision history, which is used for informational purposes as well as for rollbacks to previous versions.\nThis should only be changed in exceptional circumstances.\nSetting to zero will store no history. This will reduce storage used.\nIncreasing will increase the space used to store the history, so we do not recommend increasing it.\nDefault is 10."},"sources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSource"},"title":"Sources is a reference to the location of the application's manifests or chart"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydrator"}},"description":"ApplicationSpec represents desired application state. Contains link to repository with application definition and additional parameters link definition revision."},"applicationsApplicationSource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the repository (Git or Helm) that contains the application manifests"},"path":{"type":"string","description":"Path is a directory path within the Git repository, and is only valid for applications sourced from Git."},"targetRevision":{"type":"string","description":"TargetRevision defines the revision of the source to sync the application to.\nIn case of Git, this can be commit, tag, or branch. If omitted, will equal to HEAD.\nIn case of Helm, this is a semver tag for the Chart's version."},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"ksonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceKsonnet"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"},"chart":{"type":"string","description":"Chart is a Helm chart name, and must be specified for applications sourced from a Helm repo."},"ref":{"type":"string","description":"Ref is reference to another source within sources field. This field will not be used if used with a `source` tag."},"name":{"type":"string","description":"Name is used to refer to a source and is displayed in the UI. It is used in multi-source Applications."},"tagPrefix":{"type":"string","description":"TagPrefix filters git tags to only those with this prefix before evaluating targetRevision as a semver constraint.\nThe prefix is stripped from tag names before comparison and re-added to the resolved version.\nFor example, with tagPrefix \"component-b/\" and targetRevision \"1.0.*\", tags like \"component-b/1.0.0\" and\n\"component-b/1.0.1\" are candidates, and the constraint resolves to \"component-b/1.0.1\"."}},"title":"ApplicationSource contains all information about the source of an application"},"applicationsApplicationSourceHelm":{"type":"object","properties":{"valueFiles":{"type":"array","items":{"type":"string"},"title":"ValuesFiles is a list of Helm value files to use when generating a template"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmParameter"},"title":"Parameters is a list of Helm parameters which are passed to the helm template command upon manifest generation"},"releaseName":{"type":"string","title":"ReleaseName is the Helm release name to use. If omitted it will use the application name"},"values":{"type":"string","title":"Values specifies Helm values to be passed to helm template, typically defined as a block"},"fileParameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsHelmFileParameter"},"title":"FileParameters are file parameters to the helm template"},"version":{"type":"string","title":"Version is the Helm version to use for templating (either \"2\" or \"3\")"},"passCredentials":{"type":"boolean","title":"PassCredentials pass credentials to all domains (Helm's --pass-credentials)"},"ignoreMissingValueFiles":{"type":"boolean","title":"IgnoreMissingValueFiles prevents helm template from failing when valueFiles do not exist locally by not appending them to helm template --values"},"skipCrds":{"type":"boolean","title":"SkipCrds skips custom resource definition installation step (Helm's --skip-crds)"},"valuesObject":{"type":"object","title":"ValuesObject specifies Helm values to be passed to helm template, defined as a map. This takes precedence over Values.\n+kubebuilder:pruning:PreserveUnknownFields"},"namespace":{"type":"string","description":"Namespace is an optional namespace to template with. If left empty, defaults to the app's destination namespace."},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"skipTests":{"type":"boolean","description":"SkipTests skips test manifest installation step (Helm's --skip-tests)."},"skipSchemaValidation":{"type":"boolean","title":"SkipSchemaValidation skips JSON schema validation (Helm's --skip-schema-validation)"}},"title":"ApplicationSourceHelm holds helm specific options\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"applicationsHelmParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"value":{"type":"string","title":"Value is the value for the Helm parameter"},"forceString":{"type":"boolean","title":"ForceString determines whether to tell Helm to interpret booleans and numbers as strings"}},"title":"HelmParameter is a parameter that's passed to helm template during manifest generation"},"applicationsHelmFileParameter":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the Helm parameter"},"path":{"type":"string","title":"Path is the path to the file containing the values for the Helm parameter"}},"title":"HelmFileParameter is a file parameter that's passed to helm template during manifest generation"},"applicationsApplicationSourceKustomize":{"type":"object","properties":{"namePrefix":{"type":"string","title":"NamePrefix overrides the namePrefix in the kustomization.yaml for Kustomize apps"},"nameSuffix":{"type":"string","title":"NameSuffix overrides the nameSuffix in the kustomization.yaml for Kustomize apps"},"images":{"type":"array","items":{"type":"string"},"title":"Images is a list of Kustomize image override specifications"},"commonLabels":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonLabels is a list of additional labels to add to rendered manifests"},"version":{"type":"string","title":"Version controls which version of Kustomize to use for rendering manifests"},"commonAnnotations":{"type":"object","additionalProperties":{"type":"string"},"title":"CommonAnnotations is a list of additional annotations to add to rendered manifests"},"forceCommonLabels":{"type":"boolean","title":"ForceCommonLabels specifies whether to force applying common labels to resources for Kustomize apps"},"forceCommonAnnotations":{"type":"boolean","title":"ForceCommonAnnotations specifies whether to force applying common annotations to resources for Kustomize apps"},"namespace":{"type":"string","title":"Namespace sets the namespace that Kustomize adds to all resources"},"commonAnnotationsEnvsubst":{"type":"boolean","title":"CommonAnnotationsEnvsubst specifies whether to apply env variables substitution for annotation values"},"replicas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizeReplicas"},"title":"Replicas is a list of Kustomize Replicas override specifications"},"patches":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKustomizePatch"},"title":"Patches is a list of Kustomize patches"},"components":{"type":"array","items":{"type":"string"},"title":"Components specifies a list of kustomize components to add to the kustomization before building"},"labelWithoutSelector":{"type":"boolean","title":"LabelWithoutSelector specifies whether to apply common labels to resource selectors or not"},"kubeVersion":{"type":"string","description":"KubeVersion specifies the Kubernetes API version to pass to Helm when templating manifests. By default, Argo CD\nuses the Kubernetes version of the target cluster."},"apiVersions":{"type":"array","items":{"type":"string"},"description":"APIVersions specifies the Kubernetes resource API versions to pass to Helm when templating manifests. By default,\nArgo CD uses the API versions of the target cluster. The format is [group/]version/kind."},"ignoreMissingComponents":{"type":"boolean","title":"IgnoreMissingComponents prevents kustomize from failing when components do not exist locally by not appending them to kustomization file"},"labelIncludeTemplates":{"type":"boolean","title":"LabelIncludeTemplates specifies whether to apply common labels to resource templates or not"}},"title":"ApplicationSourceKustomize holds options specific to an Application source specific to Kustomize"},"applicationsKustomizeReplicas":{"type":"object","properties":{"count":{"type":"string","title":"Number of replicas"},"name":{"type":"string","title":"Name of Deployment or StatefulSet"}}},"applicationsKustomizePatch":{"type":"object","properties":{"path":{"type":"string"},"patch":{"type":"string"},"target":{"$ref":"#/components/schemas/applicationsKustomizeSelector"},"options":{"type":"object","additionalProperties":{"type":"boolean"}}}},"applicationsKustomizeSelector":{"type":"object","properties":{"resId":{"$ref":"#/components/schemas/applicationsKustomizeResId"},"annotationSelector":{"type":"string"},"labelSelector":{"type":"string"}}},"applicationsKustomizeResId":{"type":"object","properties":{"gvk":{"$ref":"#/components/schemas/applicationsKustomizeGvk"},"name":{"type":"string"},"namespace":{"type":"string"}}},"applicationsKustomizeGvk":{"type":"object","properties":{"group":{"type":"string"},"version":{"type":"string"},"kind":{"type":"string"}}},"applicationsApplicationSourceKsonnet":{"type":"object","properties":{"environment":{"type":"string","title":"Environment is a ksonnet application environment name"},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsKsonnetParameter"},"title":"Parameters are a list of ksonnet component parameter override values"}},"title":"ApplicationSourceKsonnet holds ksonnet specific options"},"applicationsKsonnetParameter":{"type":"object","properties":{"component":{"type":"string"},"name":{"type":"string"},"value":{"type":"string"}},"title":"KsonnetParameter is a ksonnet component parameter"},"applicationsApplicationSourceDirectory":{"type":"object","properties":{"recurse":{"type":"boolean","title":"Recurse specifies whether to scan a directory recursively for manifests"},"jsonnet":{"$ref":"#/components/schemas/applicationsApplicationSourceJsonnet"},"exclude":{"type":"string","title":"Exclude contains a glob pattern to match paths against that should be explicitly excluded from being used during manifest generation"},"include":{"type":"string","title":"Include contains a glob pattern to match paths against that should be explicitly included during manifest generation"}},"title":"ApplicationSourceDirectory holds options for applications of type plain YAML or Jsonnet"},"applicationsApplicationSourceJsonnet":{"type":"object","properties":{"extVars":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"ExtVars is a list of Jsonnet External Variables"},"tlas":{"type":"array","items":{"$ref":"#/components/schemas/applicationsJsonnetVar"},"title":"TLAS is a list of Jsonnet Top-level Arguments"},"libs":{"type":"array","items":{"type":"string"},"title":"Additional library search dirs"}},"title":"ApplicationSourceJsonnet holds options specific to applications of type Jsonnet"},"applicationsJsonnetVar":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"},"code":{"type":"boolean"}},"title":"JsonnetVar represents a variable to be passed to jsonnet during manifest generation"},"applicationsApplicationSourcePlugin":{"type":"object","properties":{"name":{"type":"string"},"env":{"type":"array","items":{"$ref":"#/components/schemas/applicationsEnvEntry"}},"parameters":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationSourcePluginParameter"}}},"title":"ApplicationSourcePlugin holds options specific to config management plugins"},"applicationsEnvEntry":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the variable, usually expressed in uppercase"},"value":{"type":"string","title":"Value is the value of the variable"}},"title":"EnvEntry represents an entry in the application's environment"},"applicationsApplicationSourcePluginParameter":{"type":"object","properties":{"name":{"type":"string","description":"Name is the name identifying a parameter."},"string":{"type":"string","description":"String_ is the value of a string type parameter."},"map":{"$ref":"#/components/schemas/applicationsOptionalMap"},"array":{"$ref":"#/components/schemas/applicationsOptionalArray"}}},"applicationsOptionalMap":{"type":"object","properties":{"map":{"type":"object","additionalProperties":{"type":"string"},"title":"Map is the value of a map type parameter.\n+optional"}}},"applicationsOptionalArray":{"type":"object","properties":{"array":{"type":"array","items":{"type":"string"},"title":"Array is the value of an array type parameter.\n+optional"}}},"applicationsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"applicationsSyncPolicy":{"type":"object","properties":{"automated":{"$ref":"#/components/schemas/applicationsSyncPolicyAutomated"},"syncOptions":{"type":"array","items":{"type":"string"},"title":"Options allow you to specify whole app sync-options"},"retry":{"$ref":"#/components/schemas/applicationsRetryStrategy"},"managedNamespaceMetadata":{"$ref":"#/components/schemas/applicationsManagedNamespaceMetadata"}},"title":"SyncPolicy controls when a sync will be performed in response to updates in git"},"applicationsSyncPolicyAutomated":{"type":"object","properties":{"prune":{"type":"boolean","title":"Prune specifies whether to delete resources from the cluster that are not found in the sources anymore as part of automated sync (default: false)"},"selfHeal":{"type":"boolean","title":"SelfHeal specifes whether to revert resources back to their desired state upon modification in the cluster (default: false)"},"allowEmpty":{"type":"boolean","title":"AllowEmpty allows apps have zero live resources (default: false)"},"enabled":{"type":"boolean","title":"Enable allows apps to explicitly control automated sync"}},"title":"SyncPolicyAutomated controls the behavior of an automated sync"},"applicationsRetryStrategy":{"type":"object","properties":{"limit":{"type":"string","format":"int64","description":"Limit is the maximum number of attempts for retrying a failed sync. If set to 0, no retries will be performed."},"backoff":{"$ref":"#/components/schemas/applicationsBackoff"},"refresh":{"type":"boolean","title":"Refresh indicates if the latest revision should be used on retry instead of the initial one (default: false)"}},"title":"RetryStrategy contains information about the strategy to apply when a sync failed"},"applicationsBackoff":{"type":"object","properties":{"duration":{"type":"string","title":"Duration is the amount to back off. Default unit is seconds, but could also be a duration (e.g. \"2m\", \"1h\")"},"factor":{"type":"string","format":"int64","title":"Factor is a factor to multiply the base duration after each failed retry"},"maxDuration":{"type":"string","title":"MaxDuration is the maximum amount of time allowed for the backoff strategy"}},"title":"Backoff is the backoff strategy to use on subsequent retries for failing syncs"},"applicationsManagedNamespaceMetadata":{"type":"object","properties":{"labels":{"type":"object","additionalProperties":{"type":"string"}},"annotations":{"type":"object","additionalProperties":{"type":"string"}}}},"applicationsResourceIgnoreDifferences":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"},"namespace":{"type":"string"},"jsonPointers":{"type":"array","items":{"type":"string"}},"jqPathExpressions":{"type":"array","items":{"type":"string"}},"managedFieldsManagers":{"type":"array","items":{"type":"string"},"title":"ManagedFieldsManagers is a list of trusted managers. Fields mutated by those managers will take precedence over the\ndesired state defined in the SCM and won't be displayed in diffs"}},"description":"ResourceIgnoreDifferences contains resource filter and list of json paths which should be ignored during comparison with live state."},"applicationsInfo":{"type":"object","properties":{"name":{"type":"string"},"value":{"type":"string"}}},"applicationsSourceHydrator":{"type":"object","properties":{"drySource":{"$ref":"#/components/schemas/applicationsDrySource"},"syncSource":{"$ref":"#/components/schemas/applicationsSyncSource"},"hydrateTo":{"$ref":"#/components/schemas/applicationsHydrateTo"}},"description":"SourceHydrator specifies a dry \"don't repeat yourself\" source for manifests, a sync source from which to sync\nhydrated manifests, and an optional hydrateTo location to act as a \"staging\" aread for hydrated manifests."},"applicationsDrySource":{"type":"object","properties":{"repoURL":{"type":"string","title":"RepoURL is the URL to the git repository that contains the application manifests"},"targetRevision":{"type":"string","title":"TargetRevision defines the revision of the source to hydrate"},"path":{"type":"string","title":"Path is a directory path within the Git repository where the manifests are located"},"helm":{"$ref":"#/components/schemas/applicationsApplicationSourceHelm"},"kustomize":{"$ref":"#/components/schemas/applicationsApplicationSourceKustomize"},"directory":{"$ref":"#/components/schemas/applicationsApplicationSourceDirectory"},"plugin":{"$ref":"#/components/schemas/applicationsApplicationSourcePlugin"}},"description":"DrySource specifies a location for dry \"don't repeat yourself\" manifest source information."},"applicationsSyncSource":{"type":"object","properties":{"targetBranch":{"type":"string","description":"TargetBranch is the branch from which hydrated manifests will be synced.\nIf HydrateTo is not set, this is also the branch to which hydrated manifests are committed."},"path":{"type":"string","description":"Path is a directory path within the git repository where hydrated manifests should be committed to and synced\nfrom. The Path should never point to the root of the repo. If hydrateTo is set, this is just the path from which\nhydrated manifests will be synced.\n\n+kubebuilder:validation:Required\n+kubebuilder:validation:MinLength=1\n+kubebuilder:validation:Pattern=`^.{2,}|[^./]$`"},"repoURL":{"type":"string","description":"RepoURL is the URL to the git repository that contains the hydrated manifests. If not set, defaults to\nthe DrySource.RepoURL."}},"description":"SyncSource specifies a location from which hydrated manifests may be synced. If RepoURL is not set, it is assumed\nto be the same as the associated DrySource config in the SourceHydrator."},"applicationsHydrateTo":{"type":"object","properties":{"targetBranch":{"type":"string","title":"TargetBranch is the branch to which hydrated manifests should be committed"}},"description":"HydrateTo specifies a branch to which hydrated manifests should be pushed as a \"staging area\" before being moved to\nthe SyncSource. The repository and path are inherited from SyncSource."},"applicationsApplicationStatus":{"type":"object","properties":{"resources":{"type":"array","items":{"$ref":"#/components/schemas/applicationsResourceStatus"},"title":"Resources is a list of Kubernetes resources managed by this application"},"sync":{"$ref":"#/components/schemas/applicationsSyncStatus"},"health":{"$ref":"#/components/schemas/applicationsAppHealthStatus"},"history":{"type":"array","items":{"$ref":"#/components/schemas/applicationsRevisionHistory"},"title":"History contains information about the application's sync history"},"conditions":{"type":"array","items":{"$ref":"#/components/schemas/applicationsApplicationCondition"},"title":"Conditions is a list of currently observed application conditions"},"reconciledAt":{"$ref":"#/components/schemas/v1Time"},"operationState":{"$ref":"#/components/schemas/applicationsOperationState"},"observedAt":{"$ref":"#/components/schemas/v1Time"},"sourceType":{"type":"string","title":"SourceType specifies the type of this application"},"summary":{"$ref":"#/components/schemas/applicationsApplicationSummary"},"resourceHealthSource":{"type":"string","title":"ResourceHealthSource indicates where the resource health status is stored: inline if not set or appTree"},"sourceTypes":{"type":"array","items":{"type":"string"},"title":"SourceTypes specifies the type of the sources included in the application"},"controllerNamespace":{"type":"string","title":"ControllerNamespace indicates the namespace in which the application controller is located"},"sourceHydrator":{"$ref":"#/components/schemas/applicationsSourceHydratorStatus"}},"title":"ApplicationStatus contains status information for the application"},"applicationsResourceStatus":{"type":"object","properties":{"group":{"type":"string","description":"Group represents the API group of the resource (e.g., \"apps\" for Deployments)."},"version":{"type":"string","description":"Version indicates the API version of the resource (e.g., \"v1\", \"v1beta1\")."},"kind":{"type":"string","description":"Kind specifies the type of the resource (e.g., \"Deployment\", \"Service\")."},"namespace":{"type":"string","description":"Namespace defines the Kubernetes namespace where the resource is located."},"name":{"type":"string","description":"Name is the unique name of the resource within the namespace."},"status":{"type":"string","description":"Status represents the synchronization state of the resource (e.g., Synced, OutOfSync)."},"health":{"$ref":"#/components/schemas/applicationsHealthStatus"},"hook":{"ty
[...]
